#include <cassert>
#include <cstring>

#include "CompressedTable.hpp"

CompressedTable::CompressedTable()
{
	m_table.insert("gz");
	m_table.insert("bz2");
	m_table.insert("zip");
	m_table.insert("tgz");
	m_table.insert("lzo");
	m_table.insert("rar");

	m_table.insert("rpm");
	m_table.insert("deb");

	m_table.insert("chm");

	m_table.insert("cab");

	// Graphics documents
	// 
	m_table.insert("gif");
	m_table.insert("jpg");
	m_table.insert("png");

	// Multimedia documents
	// 
	m_table.insert("mp3");
	m_table.insert("ogg");
	m_table.insert("avi");
	m_table.insert("mov");
}

CompressedTable::~CompressedTable()
{
	m_table.clear();
}

bool CompressedTable::isNativelyCompressed(const char *name) const
{
	assert (name);

	const char *p = strrchr(name, '.');

	if (p != NULL)
	{
		if (m_table.find(++p) != m_table.end())
		{
			return true;
		}
	}
	return false;
}

#ifdef TEST_COMPRESSEDTABLE

#include <iostream>

int main(int argc, char **argv)
{
	CompressedTable t;

	if (argc != 2)
		return 0;
	
	if (t.isNativelyCompressed(argv[1]))
		cout << "is already compressed";
	else
		cout << "is uncompressed";
	
	cout << endl;
	return 0;
}

#endif

