#ifndef MUTEX_H
#define MUTEX_H

#include <pthread.h>

class Mutex
{
	pthread_mutex_t	m_Mutex;

public:
	Mutex(bool recurent = false)
	{
		pthread_mutexattr_t type;

		pthread_mutexattr_init(&type);
		pthread_mutexattr_settype(&type, (recurent) ?
		                      PTHREAD_MUTEX_RECURSIVE : PTHREAD_MUTEX_NORMAL);

		pthread_mutex_init(&m_Mutex, &type);
	}
	
	~Mutex()
	{
		pthread_mutex_destroy(&m_Mutex);
	}

	void Lock(void)
	{
		pthread_mutex_lock(&m_Mutex);
	}
	
	void Unlock(void)
	{
		pthread_mutex_unlock(&m_Mutex);
	}
};

#endif

